// 
//

#include "stdafx.h"
#include <stdio.h>
#include "Tlhelp32.h"
#include "..\common\WebUtil.h"
#include "chx.h"

static void Error(MyVarMem* pRes, char* pszErrorString);
static void ShowGlobalMemoryStatus(WebUtil* pwu);
static BOOL ShowProcess(WebUtil* pwu);
static BOOL ShowThread(WebUtil*pwu, HANDLE hSS, LPPROCESSENTRY32 pe32);
static BOOL ShowHeap(WebUtil* pwu, LPPROCESSENTRY32 pe32);
static void ShowSystemInfo(WebUtil* pwu);
static void ShowLocalTime(WebUtil* pwu);
static void ShowOSVersion(WebUtil* pwu);


//*****************************************************************************
//
// fhChx
//	@etail
//		CGI[gDoc[gzɂ邱ƂKvƂȂ܂
//		Ƃ ../<cgiroot>/cgi.cgiȂǂ͔F܂
//		Ăяoɂ..͎gȂ
//
//		ԓ͕KCRLFŉs܂B
//		sڂ́uContent-Type: vLqĂB
//
// ----------------------------------------------------------------------------
//
//	@param
//		MyHash*		pEnv		ϐ܂
//		MyVarMem*	pBody		POSTꂽꍇANGXg{fB܂
//		MyVarMem*	pRes		NCAgɕԂeǉ܂
//
//	@return
//		pResɋlߍ񂾃oCgԂĂB
//
//*****************************************************************************
int fnChx(MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes)
{
	WebUtil wu(pEnv, pBody, pRes);

	pRes->Add("Content-Type: text/html\r\n\r\n");
	pRes->Add("<HTML><HEAD>CEHTTP Status.chx</HEAD><BODY><PRE>\n");
	
	ShowOSVersion(&wu);
	ShowSystemInfo(&wu);
	ShowGlobalMemoryStatus(&wu);
	ShowLocalTime(&wu);
	
	if( !ShowProcess(&wu) )
	{
		return pRes->GetLength();
	}

	pRes->Add(
		"<PRE>"
		"<HR>"
		"<A HREF=\"http://www001.upp.so-net.ne.jp/ishi/\">CEHTTP2 by IshiSoft</A>"
		"</BODY></HTML>");
	return pRes->GetLength();
}

//*****************************************************************************
//
// DllMain
//
//*****************************************************************************
BOOL APIENTRY DllMain(
	HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

// ----------------------------------------------------------------------------
// G[\
// ----------------------------------------------------------------------------
static void Error(MyVarMem* pRes, char* pszErrorString)
{
	pRes->Clear();
	pRes->Add("Content-Type: text/html\r\n\r\n");
	pRes->Add("<HTML><BODY>");
	pRes->Add(pszErrorString);
	pRes->Add("</BODY></HTML>");
}

// ----------------------------------------------------------------------------
// 
// ----------------------------------------------------------------------------
static void ShowSystemInfo(WebUtil* pwu)
{
	MyVarMem* pRes = pwu->GetRes();

	char szBuf[512];
	SYSTEM_INFO	si = {0};
	char* pPType;

	GetSystemInfo( &si );

	switch( si.dwProcessorType )
	{
	case PROCESSOR_INTEL_386:				pPType = "INTEL 386";	break;
	case PROCESSOR_INTEL_486:				pPType = "INTEL 486";	break;
	case PROCESSOR_INTEL_PENTIUM:			pPType = "PENTIUM";		break;
	case PROCESSOR_INTEL_860:				pPType = "INTEL 860";	break;
	case PROCESSOR_MIPS_R4000:				pPType = "MIPS R4000";	break;
	case 10003/*PROCESSOR_HITACHI_SH3*/:	pPType = "SH3";			break;
	case 10004/*PROCESSOR_HITACHI_SH3E*/:	pPType = "SH3E";		break;
	case PROCESSOR_HITACHI_SH4:				pPType = "SH4";			break;
	case 821/*PROCESSOR_MOTOROLA_821*/:		pPType = "MOTOROLA 821";break;
	case PROCESSOR_SHx_SH3:					pPType = "SHx3";		break;
	case PROCESSOR_SHx_SH4:					pPType = "SHx4";		break;
	case PROCESSOR_STRONGARM:				pPType = "STRONG ARM";	break;
	case PROCESSOR_ARM720:					pPType = "ARM720";		break;
	case PROCESSOR_ARM820:					pPType = "ARM820";		break;
	case PROCESSOR_ARM920:					pPType = "ARM920";		break;
	case 70001/*PROCESSOR_ARM_7TDMI*/:		pPType = "ARM 7TDMI";	break;
	default:								pPType = "UNKNOWN";		break;
	}

	sprintf(szBuf,
		"<B><U>Processer</U></B>\n"
		"%s\n\n"
		, pPType
		);

	pRes->Add( szBuf );

}

// ----------------------------------------------------------------------------
// 
// ----------------------------------------------------------------------------
static void ShowLocalTime(WebUtil* pwu)
{
	MyVarMem* pRes = pwu->GetRes();

	char szBuf[512];
	SYSTEMTIME st;
	DWORD dwTick;

	GetLocalTime( &st );
	dwTick = GetTickCount();

	dwTick /= 1000;	// msec -> sec

	sprintf( szBuf,
		"<B><U>LocalTime</U></B>\n"
		"%04d/%02d/%02d %02d:%02d:%02d\n"
		"TickCount %02ddays %02dhours\n\n"
		, st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond
		, dwTick / 86400, (dwTick % 86400) / 3600
		);

	pRes->Add( szBuf );
}

// ----------------------------------------------------------------------------
// 
// ----------------------------------------------------------------------------
static void ShowOSVersion(WebUtil* pwu)
{
	MyVarMem* pRes = pwu->GetRes();

	char szBuf[512];
	OSVERSIONINFO osvi = {0};

	osvi.dwOSVersionInfoSize = sizeof( OSVERSIONINFO );
	GetVersionEx( &osvi );

	char* pPlatform;
	
	switch( osvi.dwPlatformId )
	{
	case VER_PLATFORM_WIN32s:			pPlatform = "Windows32s";	break;
	case VER_PLATFORM_WIN32_WINDOWS:	pPlatform = "Windows32";	break;
	case VER_PLATFORM_WIN32_NT:			pPlatform = "WindowsNT";	break;
	case VER_PLATFORM_WIN32_CE:			pPlatform = "WindowsCE";	break;
	default:							pPlatform = "UNKNOWN";		break;
	}
	sprintf( szBuf,
		"<B><U>OS Version</U></B>\n"
		"%s %d.%d(build %d)%s\n\n"
		, pPlatform, osvi.dwMajorVersion, osvi.dwMinorVersion, osvi.dwBuildNumber, osvi.szCSDVersion
		);

	pRes->Add( szBuf );

}

// ----------------------------------------------------------------------------
// 
// ----------------------------------------------------------------------------
static void ShowGlobalMemoryStatus(WebUtil* pwu)
{
	MyVarMem* pRes = pwu->GetRes();

	char szBuf[512];
	MEMORYSTATUS	ms = {0};
	ms.dwLength = sizeof(MEMORYSTATUS);
	GlobalMemoryStatus( &ms );

	DWORD dwTotalPhys = ms.dwTotalPhys/1024;
	DWORD dwAvailPhys = ms.dwAvailPhys/1024;
	DWORD dwUsedPhys = dwTotalPhys - dwAvailPhys;

	DWORD dwUsedImage  = dwUsedPhys / 100;
	DWORD dwAvailImage = dwAvailPhys / 100;

	sprintf(szBuf,
		"<B><U>Memory</U></B>\n"
		//"<img src=\"/images/blue_bar.gif\" width=\"%d\" height=\"16\">"
		//"<img src=\"/images/gray_bar.gif\" width=\"%d\" height=\"16\">\n"
		"Total: %dKB / Used: %dKB / Avali:%dKB\n\n"

		//, dwUsedImage
		//, dwAvailImage
		, dwTotalPhys, dwUsedPhys, dwAvailPhys
		);

	pRes->Add( szBuf );

	// ----------------------------------------------------
	STORE_INFORMATION si;

	GetStoreInformation(&si);

	sprintf(szBuf,
		"<B><U>Object tore</U></B>\n"
		//"<img src=\"/images/blue_bar.gif\" width=\"%d\" height=\"16\">"
		//"<img src=\"/images/gray_bar.gif\" width=\"%d\" height=\"16\">\n"
		"Total: %dKB / Used: %dKB / Avali:%dKB\n\n"

		//, (si.dwStoreSize - si.dwFreeSize) / 102400
		//, (si.dwFreeSize) / 102400
		, si.dwStoreSize / 1024
		, (si.dwStoreSize - si.dwFreeSize) / 1024
		, si.dwFreeSize / 1024
		);

	pRes->Add( szBuf );
}

// ----------------------------------------------------------------------------
// 
// ----------------------------------------------------------------------------
static BOOL ShowProcess(WebUtil* pwu)
{
	char szFmt[1024];
	MyVarMem* pRes = pwu->GetRes();
	BOOL bRet;

	HANDLE hSS;
	hSS = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS | TH32CS_SNAPTHREAD, 0);

	if( hSS == (void*)-1 )
	{
		Error(pRes, "Error:CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS|TH32CS_SNAPTHREAD)");
		return FALSE;
	}

	PROCESSENTRY32 pe32;
	memset(&pe32, 0, sizeof(PROCESSENTRY32));
	pe32.dwSize = sizeof(PROCESSENTRY32);

	bRet = Process32First(hSS, &pe32);

	if( pe32.dwSize != sizeof(PROCESSENTRY32) )
	{
		Error(pRes, "Error:Process32First unmuched structure size.");
		CloseToolhelp32Snapshot(hSS);
		return FALSE;
	}

	// ----------------------------------------------------
	// Table header
	// ----------------------------------------------------
	pRes->Add(
		"<p><B><U>Process           ProcessID Threads</U></B>\n" );
	// ----------------------------------------------------
	// Table body
	// ----------------------------------------------------
	do
	{
		char* pExeName = WStrToStrAlloc(pe32.szExeFile);
		if( !pExeName )
		{
			CloseToolhelp32Snapshot(hSS);
			Error(pRes, "Error:WStrToStrAlloc returned NULL.");
			return FALSE;
		}
		sprintf(szFmt,
			"<B>%-20s</B> %08X % 4d\n"
			, pExeName, pe32.th32ProcessID, pe32.cntThreads );
				
		free( pExeName );
		pRes->Add(szFmt);


		if( !ShowThread(pwu, hSS, &pe32) )
		{
			CloseToolhelp32Snapshot(hSS);
			return FALSE;
		}

		if( !ShowHeap(pwu, &pe32) )
		{
			CloseToolhelp32Snapshot(hSS);
			return FALSE;
		}

		bRet = Process32Next(hSS, &pe32);
	}while( bRet != FALSE );

	CloseToolhelp32Snapshot(hSS);

	return TRUE;
}

// ----------------------------------------------------------------------------
// 
// ----------------------------------------------------------------------------
static BOOL ShowThread(WebUtil*pwu, HANDLE hSS, LPPROCESSENTRY32 pe32)
{
	char szFmt[1024];
	MyVarMem* pRes = pwu->GetRes();

	if( hSS == (void*)-1 )
	{
		Error(pRes, "Error:CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD)");
		return FALSE;
	}	

	THREADENTRY32 te32;
	memset( &te32, 0, sizeof(THREADENTRY32));
	te32.dwSize = sizeof(THREADENTRY32);

	if( !Thread32First(hSS, &te32) )
	{
		if( ERROR_NO_MORE_FILES == GetLastError() )
			return TRUE;

		Error(pRes, "Error:Thread32First failed");
		return FALSE;
	}

	pRes->Add("    <U>Thread detail      ID         Priority                 .</U>\n");
	do
	{
		if( pe32->th32ProcessID == te32.th32OwnerProcessID )
		{
			sprintf( szFmt,
				"                    %08X  %10d\n"

				, te32.th32ThreadID, te32.tpBasePri);

			pRes->Add( szFmt );
		}
	}while( Thread32Next(hSS, &te32) );
	
	pRes->Add("\n");

	return TRUE;
}

// ----------------------------------------------------------------------------
// 
// ----------------------------------------------------------------------------
static BOOL ShowHeap(WebUtil* pwu, LPPROCESSENTRY32 pe32)
{
	char szFmt[1024];
	MyVarMem* pRes = pwu->GetRes();

	HANDLE hSS;
	hSS = CreateToolhelp32Snapshot(TH32CS_SNAPHEAPLIST, pe32->th32ProcessID);

	if( hSS == (void*)-1 )
	{
		Error(pRes, "Error:CreateToolhelp32Snapshot(TH32CS_SNAPHEAPLIST)");
		return FALSE;
	}	
	
	HEAPLIST32 hl32;
	memset(&hl32, 0, sizeof(HEAPLIST32));
	hl32.dwSize = sizeof(HEAPLIST32);

	if( !Heap32ListFirst(hSS, &hl32) )
	{
		CloseToolhelp32Snapshot(hSS);

		if( ERROR_NO_MORE_FILES == GetLastError() )
			return TRUE;

		Error(pRes, "Error:Heap32ListFirst failed");
		return FALSE;
	}

	DWORD dwTotalHeapByte = 0;
	DWORD dwTotalProcessByte = 0;

	BOOL bMemoryDetail = pwu->GetItemInt("memory_detail");

	pRes->Add("    <U>Heap detail        ID         heap size                .</U>\n");
	do
	{
		HEAPENTRY32 he32;
		memset(&he32, 0, sizeof(HEAPENTRY32));
		he32.dwSize = sizeof(HEAPENTRY32);

		if( !Heap32First( hSS, &he32, hl32.th32ProcessID, hl32.th32HeapID ) )
		{
			Error(pRes, "Error:Heap32First failed");
			CloseToolhelp32Snapshot(hSS);
			return FALSE;
		}

		if(bMemoryDetail)
			pRes->Add( "                     <U>Address         Size   BIGBLK DECMT FIXED FREE LockCount</U>\n" );

		do
		{
			if(bMemoryDetail)
			{
				sprintf(szFmt,
					"                    %08X  %10dB % 6s% 6s% 6s% 6s% 6d\n"
					, he32.dwAddress
					, he32.dwBlockSize
					, he32.dwFlags&LF32_BIGBLOCK ? "*" : "-"
					, he32.dwFlags&LF32_DECOMMIT ? "*" : "-"
					, he32.dwFlags&LF32_FIXED    ? "*" : "-"
					, he32.dwFlags&LF32_FREE     ? "*" : "-"
					, he32.dwLockCount );
					
				pRes->Add(szFmt);
			}

			if( he32.dwFlags&LF32_FIXED )
				dwTotalHeapByte += he32.dwBlockSize;

		}while( Heap32Next( hSS, &he32 ) );

		sprintf( szFmt,
			"                    %08X  %10dB(%dKB)\n"
			, hl32.th32HeapID, dwTotalHeapByte, dwTotalHeapByte/1024 );

		pRes->Add(szFmt);

		dwTotalProcessByte += dwTotalHeapByte;

	}while( Heap32ListNext( hSS, &hl32 ) );

	pRes->Add("\n");

	CloseToolhelp32Snapshot(hSS);

	return TRUE;
	
}

